## libbgcode 0.0~git20231219.7aaf717

=== debian/changelog ===
libbgcode (0.0~git20231219.7aaf717-1) unstable; urgency=medium

  * [48bee50] New upstream version 0.0~git20231219.7aaf717
  * [dfb8267] Add manpage for bgcode binary
  * [c21ebb5] Ignore manpage lintian warning.
    The manpage is generated by pandoc and there's no fix for this
  * [c75c18a] Switch debian packaging to AGPL-3 to match upstream code

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 06 Jan 2024 04:27:13 +0800

libbgcode (0.0~git20231208.02d005c-1) unstable; urgency=medium

  * Initial release. (Closes: #1056335)

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 20 Nov 2023 11:38:34 +0800

## libbgcode 0.0~git20240206.27ebf16

=== debian/changelog ===
libbgcode (0.0~git20240206.27ebf16-1) unstable; urgency=medium

  * [efa574b] New upstream version 0.0~git20240206.27ebf16

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 18 Feb 2024 01:57:10 +0800

## libbgcode 0.0~git20240220.33a1eeb

=== deps/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(LibBGCode_Deps)

# Support legacy parameter DESTDIR
if (DESTDIR)
  set(${PROJECT_NAME}_DEP_INSTALL_PREFIX ${DESTDIR}/usr/local CACHE PATH "Destination directory" FORCE)
endif ()

# Support legacy parameter DEP_DOWNLOAD_DIR
if (DEP_DOWNLOAD_DIR)
  set(${PROJECT_NAME}_DEP_DOWNLOAD_DIR ${DEP_DOWNLOAD_DIR} CACHE PATH "Path for downloaded source packages." FORCE)
endif ()

# Slightly controversial
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
    cmake_policy(SET CMP0135 NEW)
endif ()

if (APPLE)
    # This ensures dependencies don't use SDK features which are not available in the version specified by Deployment target
    # That can happen when one uses a recent SDK but specifies an older Deployment target
    set(DEP_WERRORS_SDK "-Werror=partial-availability -Werror=unguarded-availability -Werror=unguarded-availability-new")

    set(DEP_CMAKE_OPTS
        "-DCMAKE_POSITION_INDEPENDENT_CODE=ON"
        "-DCMAKE_OSX_SYSROOT=${CMAKE_OSX_SYSROOT}"
        "-DCMAKE_OSX_DEPLOYMENT_TARGET=${CMAKE_OSX_DEPLOYMENT_TARGET}"
        "-DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES}"
        "-DCMAKE_CXX_FLAGS=${DEP_WERRORS_SDK}"
        "-DCMAKE_C_FLAGS=${DEP_WERRORS_SDK}"
        "-DCMAKE_FIND_FRAMEWORK=LAST"
        "-DCMAKE_FIND_APPBUNDLE=LAST"
    )
endif ()

if (EMSCRIPTEN)
    set(DEP_CMAKE_OPTS "-DCMAKE_CXX_FLAGS=-fms-extensions")
endif ()

include(${PROJECT_SOURCE_DIR}/../cmake/modules/AddCMakeProject.cmake)

set(supported_packages Boost heatshrink Catch2 ZLIB pybind11)

include(CMakeDependentOption)
option(${PROJECT_NAME}_SELECT_ALL "Choose all external projects to be selected (create build target for them)." ON)
option(${PROJECT_NAME}_BUILD_ALL "Choose all external projects to be built." OFF)

find_package(Git REQUIRED)

# The default command line for patching. Only works for newer
set(PATCH_CMD ${GIT_EXECUTABLE} apply --verbose --ignore-space-change --whitespace=fix)

foreach (pkg ${supported_packages})
    option(${PROJECT_NAME}_BUILD_${pkg} "Select package ${pkg} to be built." OFF)
    if (${PROJECT_NAME}_SELECT_ALL OR ${PROJECT_NAME}_BUILD_ALL OR ${PROJECT_NAME}_BUILD_${pkg})
        include(${pkg}/${pkg}.cmake)
    endif ()
endforeach()

install(CODE "message(STATUS \"Built packages succesfully.\")")

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(bgcode_client)

# Set C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option (BGCODE_AS_SUBPROJECT "Import bgcode library with add_subdirectory, instead of find_package" OFF)

if (BGCODE_AS_SUBPROJECT)
    add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/.. ${CMAKE_CURRENT_BINARY_DIR}/upstream)
else ()
    find_package(LibBGCode REQUIRED)
endif ()

add_executable(${PROJECT_NAME} main.cpp)

target_link_libraries(${PROJECT_NAME} LibBGCode::bgcode_convert)

=== pybgcode/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(../cmake/ProjectVersion.cmake)

project(PyBGCode VERSION ${LibBGCode_VERSION})

# Set C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(PyBGCode_LINK_SYSTEM_LIBBGCODE "Link libbgcode installed in the system" ON)

# Default values for libbgcode subproject
option(LibBGCode_BUILD_CMD_TOOL "" OFF)
option(LibBGCode_BUILD_TESTS  "" OFF)
option(LibBGCode_BUILD_DEPS "" ON)
set(LibBGCode_DEPS_PRESET "python-module" CACHE STRING "" )

if (PyBGCode_LINK_SYSTEM_LIBBGCODE)
    find_package(LibBGCode REQUIRED COMPONENTS Convert)
else ()
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/.. ${CMAKE_CURRENT_BINARY_DIR}/upstream)
endif ()

find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
find_package(pybind11 REQUIRED)

set(PY_VERSION_SUFFIX "")
set(PY_FULL_VERSION ${PROJECT_VERSION}${PY_VERSION_SUFFIX})

# Make sure that the Python and CMake versions match
if (DEFINED PY_BUILD_CMAKE_PACKAGE_VERSION)
    if (NOT "${PY_BUILD_CMAKE_PACKAGE_VERSION}" MATCHES "^${PY_FULL_VERSION}$")
        message(FATAL_ERROR "Version number does not match "
                             "(${PY_BUILD_CMAKE_PACKAGE_VERSION} - ${PY_FULL_VERSION}).")
    endif()
endif()

find_package(Boost ${Boost_VER} REQUIRED COMPONENTS nowide)

pybind11_add_module(_bgcode MODULE pybgcode.cpp)

target_link_libraries(_bgcode PRIVATE LibBGCode::bgcode_convert Boost::nowide)

target_compile_definitions(_bgcode PRIVATE
    MODULE_NAME=$<TARGET_FILE_BASE_NAME:_bgcode>
    VERSION_INFO="${PY_FULL_VERSION}"
)

# Hide all symbols by default (including external libraries on Linux)
set_target_properties(_bgcode PROPERTIES
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN true
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/pybgcode)

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    target_link_options(_bgcode PRIVATE "LINKER:--exclude-libs,ALL")
endif()

if (PY_BUILD_CMAKE_MODULE_NAME)
    # Install the Python module
    install(TARGETS _bgcode
            EXCLUDE_FROM_ALL
            COMPONENT python_modules
            DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME})
    # Install the debug file for the Python module (Windows only)
    if (WIN32)
        install(FILES $<TARGET_PDB_FILE:_bgcode>
                EXCLUDE_FROM_ALL
                COMPONENT python_modules
                DESTINATION ${PY_BUILD_CMAKE_MODULE_NAME}
                OPTIONAL)
    endif()
endif ()

enable_testing()

set (TEST_DATA_DIR ${CMAKE_CURRENT_LIST_DIR}/../tests/data)

# Prepare the test files to be available
configure_file(${TEST_DATA_DIR}/mini_cube_b_ref.gcode ${CMAKE_CURRENT_BINARY_DIR}/test.gcode)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/pybgcode DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Define the test for ctest and inject the correct PYTHONPATH env var for its runtime
add_test(NAME test_pybgcode
         COMMAND ${Python3_EXECUTABLE} -m pytest -v tests/test_convert.py
         WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         CONFIGURATIONS ${CMAKE_CONFIGURATION_TYPES})
#$<TARGET_FILE_DIR:_bgcode>:
#set_property(TEST test_pybgcode PROPERTY ENVIRONMENT PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(build_and_test COMMAND ${CMAKE_CTEST_COMMAND} --verbose DEPENDS _bgcode)

=== tests/CMakeLists.txt ===
find_package(Catch2 2.9 REQUIRED)

include(Catch)

find_package(Boost ${Boost_VER} REQUIRED COMPONENTS nowide)

if (MSVC)
    set_target_properties(Boost::nowide PROPERTIES MAP_IMPORTED_CONFIG_RELWITHDEBINFO Release)
endif ()

set(CATCH_EXTRA_ARGS "" CACHE STRING "Extra arguments for catch2 test suites.")

set(TEST_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data)
file(TO_NATIVE_PATH "${TEST_DATA_DIR}" TEST_DATA_DIR)

add_library(test_common INTERFACE)
target_include_directories(test_common INTERFACE ${CMAKE_CURRENT_LIST_DIR})
target_compile_definitions(test_common INTERFACE TEST_DATA_DIR=R"\(${TEST_DATA_DIR}\)" CATCH_CONFIG_FAST_COMPILE)
target_link_libraries(test_common INTERFACE Catch2::Catch2 Boost::nowide)

if (EMSCRIPTEN)
    target_link_libraries(test_common INTERFACE nodefs.js noderawfs.js)
endif()

add_subdirectory(core)

if (${PROJECT_NAME}_BUILD_COMPONENT_Binarize)
    add_subdirectory(binarize)
endif()

if (${PROJECT_NAME}_BUILD_COMPONENT_Convert)
    add_subdirectory(convert)
endif ()

=== debian/changelog ===
libbgcode (0.0~git20240220.33a1eeb-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:50:14 +0000

libbgcode (0.0~git20240220.33a1eeb-1) unstable; urgency=medium

  * [bb7fbd2] New upstream version 0.0~git20240220.33a1eeb

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 03 Mar 2024 17:57:59 +0800

=== debian/control ===
Source: libbgcode
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               catch2,
               cmake,
               libboost-dev,
               libboost-nowide-dev,
               libheatshrink-dev,
               pandoc,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/prusa3d/libbgcode
Vcs-Browser: https://salsa.debian.org/3dprinting-team/libbgcode
Vcs-Git: https://salsa.debian.org/3dprinting-team/libbgcode.git

Package: libbgcode-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: binary gcode generation library
 libbgcode is a library used to generate binary G-code for 3D printers.
 Binary G-code is a new G-code file format featuring the following
 improvements over the legacy G-code:
 .
 1) Block structure with distinct blocks for metadata vs. G-code
 2) Faster navigation
 3) Coding & compression for smaller file size
 4) Checksum for data validity
 5) Extensivity through new (custom) blocks. For example, a file
    signature block may be welcome by corporate customers.
 .
 This package contains the development files required to compile applications
 against this library.

Package: bgcode
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: binary gcode generation library
 libbgcode is a library used to generate binary G-code for 3D printers.
 Binary G-code is a new G-code file format featuring the following
 improvements over the legacy G-code:
 .
 1) Block structure with distinct blocks for metadata vs. G-code
 2) Faster navigation
 3) Coding & compression for smaller file size
 4) Checksum for data validity
 5) Extensivity through new (custom) blocks. For example, a file
    signature block may be welcome by corporate customers.
 .
 This package contains the bgcode command line utility used to convert textual
 gcode files into binary gcode.

## libbgcode 0.0~git20240328.8ae75bd

=== debian/changelog ===
libbgcode (0.0~git20240328.8ae75bd-1) unstable; urgency=medium

  * [947ba83] New upstream version 0.0~git20240328.8ae75bd

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 26 Apr 2024 17:38:09 +0800

## libbgcode 0.0~git20240704.dcb8f7b

=== debian/changelog ===
libbgcode (0.0~git20240704.dcb8f7b-1) unstable; urgency=medium

  * [ec9c342] New upstream version 0.0~git20240704.dcb8f7b

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 18 Jul 2024 02:27:40 +0800

## libbgcode 0.0~git20240903.3db61e4

=== debian/changelog ===
libbgcode (0.0~git20240903.3db61e4-1) unstable; urgency=medium

  * [e1c2c52] New upstream version 0.0~git20240829.b5c57c4
  * [461d5fe] New upstream version 0.0~git20240903.3db61e4

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 06 Sep 2024 11:26:29 +0800

libbgcode (0.0~git20240730.5347c33-1) unstable; urgency=medium

  * [28dc052] New upstream version 0.0~git20240730.5347c33

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 21 Aug 2024 16:27:24 +0800

## libbgcode 0.0~git20241024.d33a277

=== tests/binarize/CMakeLists.txt ===
add_executable(binarize_tests binarize_tests.cpp)

target_link_libraries(binarize_tests ${_libname}_binarize test_common)

catch_discover_tests(binarize_tests EXTRA_ARGS ${CATCH_EXTRA_ARGS})

=== debian/changelog ===
libbgcode (0.0~git20241024.d33a277-2) unstable; urgency=medium

  * [85ab0dd] Enable position-independent code generation everywhere.
    Fixes slic3r-prusa relocation-related FTBFS errors[1]
    [1] https://github.com/prusa3d/PrusaSlicer/issues/13694

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 30 Dec 2024 11:36:39 +0800

libbgcode (0.0~git20241024.d33a277-1) unstable; urgency=medium

  * [2842eba] New upstream version 0.0~git20241024.d33a277

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 12 Nov 2024 16:02:44 +0800

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

# GitHub hosted projects.
#opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
#    https://github.com/prusa3d/libbgcode/tags \
#    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

# Direct Git.
opts="mode=git" http://github.com/prusa3d/libbgcode HEAD

## libbgcode 0.0~git20250220.5041c09

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(cmake/ProjectVersion.cmake)

project(LibBGCode VERSION ${LibBGCode_VERSION})

# Set C++ standard
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(_libname ${PROJECT_NAME})
string(TOLOWER ${_libname} _libname)
string(REPLACE "lib" "" _libname ${_libname})

option(${PROJECT_NAME}_BUILD_TESTS "Build unit tests" ON)
option(${PROJECT_NAME}_BUILD_COMPONENT_Binarize "Include Binarize component in the library" ON)
option(${PROJECT_NAME}_BUILD_SANITIZERS "Turn on sanitizers" OFF)

# Dependency build management
option(${PROJECT_NAME}_BUILD_DEPS "Build dependencies before the project" OFF)
option(${PROJECT_NAME}_DEPS_OUTPUT_QUIET "Don't print build output for dependencies" ON)
option(${PROJECT_NAME}_DEPS_SHARED "Build dependencies as shared libraries" OFF)
set(${PROJECT_NAME}_DEPS_PRESET "default" CACHE STRING "Preset of the dependencies when ${PROJECT_NAME}_BUILD_DEPS is ON")
set(${PROJECT_NAME}_DEPS_BUILD_DIR "" CACHE PATH "Binary dir of the dependencies build when ${PROJECT_NAME}_BUILD_DEPS is ON")

if (${PROJECT_NAME}_BUILD_DEPS)
    include(deps/autobuild.cmake)
endif ()

if (NOT CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "d")
endif ()

include(CMakeDependentOption)
cmake_dependent_option(${PROJECT_NAME}_BUILD_COMPONENT_Convert "Include Convert component in the library" ON 
                       "${PROJECT_NAME}_BUILD_COMPONENT_Binarize" OFF)
cmake_dependent_option(${PROJECT_NAME}_BUILD_CMD_TOOL "Include bgcode command line tool in the library" ON 
                       "${PROJECT_NAME}_BUILD_COMPONENT_Convert" OFF)

if (EMSCRIPTEN)
    cmake_dependent_option(${PROJECT_NAME}_BUILD_WASM "Include bgcode wasm module in the build" ON
                          "${PROJECT_NAME}_BUILD_COMPONENT_Convert" OFF)
endif ()

set(_selected_components "Core")
set(_selected_libs "${_libname}_core")
set(_highest_comp "Core")

# Set this if downstream would need to link additional boost
# components
set(Boost_DOWNSTREAM_COMPONENTS "")

set(namespace "${PROJECT_NAME}::")

# Create an export header
include(GenerateExportHeader)

set(_srcloc src/${PROJECT_NAME})

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.rc.in
  ${PROJECT_BINARY_DIR}/version.rc
  @ONLY)

if (CMAKE_COMPILER_IS_GNUCXX)
    add_compile_options(-fvisibility=hidden)
endif ()

add_subdirectory(${_srcloc}/core)

if (${PROJECT_NAME}_BUILD_COMPONENT_Binarize)
    add_subdirectory(${_srcloc}/binarize)

    list(APPEND _selected_components Binarize)
    list(APPEND _selected_libs ${_libname}_binarize)
    set(_highest_comp "Binarize")
endif ()

if (${PROJECT_NAME}_BUILD_COMPONENT_Convert)
    add_subdirectory(${_srcloc}/convert)

    list(APPEND _selected_components Convert)
    list(APPEND _selected_libs ${_libname}_convert)
    set(_highest_comp "Convert")
endif ()

add_library(${_libname} INTERFACE)
target_link_libraries(${_libname} INTERFACE ${_selected_libs})

if (${PROJECT_NAME}_BUILD_CMD_TOOL)
    add_subdirectory(${_srcloc}/cmd)
endif ()

if (${PROJECT_NAME}_BUILD_WASM)
    add_subdirectory(${_srcloc}/wasm)
endif()

if (${PROJECT_NAME}_BUILD_PYTHON_BINDING)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif ()

if(${PROJECT_NAME}_BUILD_TESTS)
    enable_testing ()
    add_subdirectory(tests)
endif()

# Create and install the CMake config script
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

set(version_config "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake")

install(TARGETS ${_libname}
    EXPORT ${PROJECT_NAME}{_highest_comp}Targets
    INCLUDES DESTINATION include/${PROJECT_NAME}
)

foreach(_comp ${_selected_components})
    # Install targets and headers
    string(TOLOWER ${_comp} _comp_lower)
    set(_export_targets ${_libname}_${_comp_lower})

    set_target_properties(${_libname}_${_comp_lower}
        PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION})

    install(TARGETS ${_export_targets}
        EXPORT ${PROJECT_NAME}${_comp}Targets
        INCLUDES DESTINATION include/${PROJECT_NAME}
    )

    install(FILES ${_srcloc}/${_comp_lower}/${_comp_lower}.hpp DESTINATION include/${PROJECT_NAME}/${_comp_lower})
    install(FILES
        ${PROJECT_BINARY_DIR}/${_comp_lower}/export.h DESTINATION include/${PROJECT_NAME}/${_comp_lower}/
    )
    install(
        EXPORT "${PROJECT_NAME}${_comp}Targets"
        NAMESPACE "${namespace}"
        DESTINATION "${CONFIG_INSTALL_DIR}"
    )
endforeach()

write_basic_package_version_file(
    "${version_config}"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    "cmake/Config.cmake.in"
    "${project_config}"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

install(
    FILES "${project_config}" "${version_config}"
    DESTINATION "${CONFIG_INSTALL_DIR}"
)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Catch2 2.9 REQUIRED)
+find_package(Catch2 3.8 REQUIRED)
 
 include(Catch)
 
@@ -16,7 +16,7 @@
 add_library(test_common INTERFACE)
 target_include_directories(test_common INTERFACE ${CMAKE_CURRENT_LIST_DIR})
 target_compile_definitions(test_common INTERFACE TEST_DATA_DIR=R"\(${TEST_DATA_DIR}\)" CATCH_CONFIG_FAST_COMPILE)
-target_link_libraries(test_common INTERFACE Catch2::Catch2 Boost::nowide)
+target_link_libraries(test_common INTERFACE Catch2::Catch2WithMain Boost::nowide)
 
 if (EMSCRIPTEN)
     target_link_libraries(test_common INTERFACE nodefs.js noderawfs.js)

=== tests/convert/CMakeLists.txt ===
add_executable(convert_tests convert_tests.cpp)

target_link_libraries(convert_tests ${_libname}_convert test_common Boost::nowide)

catch_discover_tests(convert_tests EXTRA_ARGS ${CATCH_EXTRA_ARGS})

=== tests/core/CMakeLists.txt ===
add_executable(core_tests core_tests.cpp)

target_link_libraries(core_tests ${_libname}_core test_common)

catch_discover_tests(core_tests EXTRA_ARGS ${CATCH_EXTRA_ARGS})

=== src/LibBGCode/cmd/CMakeLists.txt ===
add_executable(${_libname}_cmd  main.cpp )

find_package(Boost ${Boost_VER} REQUIRED COMPONENTS nowide)

if (MSVC)
    set_target_properties(Boost::nowide PROPERTIES MAP_IMPORTED_CONFIG_RELWITHDEBINFO Release)
endif ()

set_target_properties(${_libname}_cmd PROPERTIES OUTPUT_NAME ${_libname})
target_link_libraries(${_libname}_cmd ${_libname}_convert Boost::nowide)


if (NOT EMSCRIPTEN)
    install(TARGETS ${_libname}_cmd
        EXPORT ${PROJECT_NAME}ConvertTargets
        RUNTIME  DESTINATION bin
        INCLUDES DESTINATION include/${PROJECT_NAME}
    )
else ()
    target_link_libraries(${_libname}_cmd nodefs.js noderawfs.js)
endif ()

=== src/LibBGCode/core/CMakeLists.txt ===
set(Core_DOWNSTREAM_DEPS "")

# Core component
add_library(${_libname}_core
   core.cpp
   core.hpp
   core_impl.hpp
   ${PROJECT_BINARY_DIR}/version.rc
   # Add more source files here if needed
)

if (${PROJECT_NAME}_BUILD_SANITIZERS)
    if (CMAKE_COMPILER_IS_GNUCC)
        target_compile_options(${_libname}_core PUBLIC
            -g
            -Wstrict-aliasing
            -fsanitize=address
        )
        target_link_options(${_libname}_core PUBLIC -fsanitize=address)
    elseif (MSVC)
        target_compile_options(${_libname}_core PUBLIC /fsanitize=address /Zi)
        target_link_options(${_libname}_core PUBLIC /DEBUG)
    endif ()
endif ()

target_compile_definitions(${_libname}_core PRIVATE LibBGCode_VERSION=R"\(${LibBGCode_VERSION}\)")

generate_export_header(${_libname}_core
   EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/core/export.h
)

target_include_directories(${_libname}_core
   PUBLIC
       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/${_srcloc}>
       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
       $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
       $<INSTALL_INTERFACE:include>
)

add_library(${namespace}${_libname}_core ALIAS ${_libname}_core)

# Set the version of the project
# target_sources(Core PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/version.h)
# target_compile_definitions(Core PRIVATE VERSION_MAJOR=${PROJECT_VERSION_MAJOR} VERSION_MINOR=${PROJECT_VERSION_MINOR})

set(Core_DOWNSTREAM_DEPS ${Core_DOWNSTREAM_DEPS} PARENT_SCOPE)

=== src/LibBGCode/wasm/CMakeLists.txt ===
add_executable(${_libname}_wasm bgcode_wa.cpp index.html)
set_target_properties(${_libname}_wasm PROPERTIES OUTPUT_NAME ${_libname})

target_link_libraries(${_libname}_wasm bgcode_convert embind)
#set_target_properties(bgcode_wa PROPERTIES SUFFIX)
target_link_options(${_libname}_wasm PUBLIC
    -s TOTAL_MEMORY=512MB
#    -sEXPORTED_RUNTIME_METHODS=stringToNewUTF8,FS
#    -sEXPORTED_FUNCTIONS=_free
)

configure_file(index.html ${CMAKE_CURRENT_BINARY_DIR}/${_libname}.html)

install(TARGETS ${_libname}_wasm
    EXPORT ${PROJECT_NAME}ConvertTargets
    RUNTIME DESTINATION lib/wasm
    INCLUDES DESTINATION include/${PROJECT_NAME}
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${_libname}.wasm
    ${CMAKE_CURRENT_BINARY_DIR}/${_libname}.html
    DESTINATION lib/wasm  # or wherever you want these files to be installed
)

=== debian/changelog ===
libbgcode (0.0~git20250220.5041c09-1) unstable; urgency=medium

  * [043f0b6] New upstream version 0.0~git20250220.5041c09
  * [164e74d] Drop upstreamed patches
  * [4569abf] Patch to downgrade catch2 dependency to 3.7.
    3.8 isn't packaged yet.
  * [f4eac2c] Drop removed file from debian/copyright

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 10 Mar 2025 23:32:41 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libbgcode
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
+Maintainer: Chow Loong Jin <hyperair@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                catch2,

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

debian/bgcode.1: debian/bgcode.md
	pandoc --standalone --from=markdown --to=man $< --output=$@

override_dh_installman: debian/bgcode.1
	dh_installman

## libbgcode 0.0~git20251210.0773cea

=== debian/changelog ===
libbgcode (0.0~git20251210.0773cea-2) unstable; urgency=medium

  * [d0e67ff] Fix FTBFS on big-endian architectures.
    Thanks to Gregor Riepl <onitake@gmail.com> (Closes: #1062014)

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 22 Dec 2025 13:15:21 +0800

libbgcode (0.0~git20251210.0773cea-1) unstable; urgency=medium

  * [a7cb976] New upstream version 0.0~git20251210.0773cea

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 15 Dec 2025 14:30:26 +0800
